#include "notifications.h"

int notifications (char *sigvalue)
{
	FILE *fp;
    if( (fp=fopen("/tmp/kylin-updateresult-notify.log","a+")) == NULL )
    {
        fprintf(fp,"Fail to open file!\n");
        return -2;
    }
	setlocale(LC_ALL, "");
	bindtextdomain("kylin-updateresult-notify","/usr/share/locale");
	textdomain("kylin-updateresult-notify");
	NotifyNotification* notification;
	gboolean            success;
	GError*             error = NULL;
	if (!notify_init (gettext("System Update")))
	{
		fprintf(fp,"notify_init failed!\n");
		return 1;
	}
	if(strcmp(sigvalue,"success") == 0){
		fprintf(fp,"upgrade success!\n");
		notification = notify_notification_new (
					// gettext("Download finish, do you want to reboot?"),
					// gettext("The system will use the new system after restarting."),
					NULL,
					gettext("Update Success!"),
					"/usr/share/icons/ukui-icon-theme-default/16x16/apps/ukui-control-center.png");
		notify_notification_set_timeout(notification, 0);
		notify_notification_add_action(notification, "OK", gettext("OK"), 
		(NotifyActionCallback)actionClose ,NULL, NULL);
		notify_notification_set_hint_int32(notification,"x-ukui-popup-timeout",-1);
	}
	else if(strcmp(sigvalue,"failed") == 0){
		fprintf(fp,"upgrade fail!\n");
		notification = notify_notification_new (
				NULL,
				gettext("Update Failed!"),
				"/usr/share/icons/ukui-icon-theme-default/16x16/apps/ukui-control-center.png");
		notify_notification_set_timeout(notification, 0);
		notify_notification_add_action(notification, "OK", gettext("OK"), 
		(NotifyActionCallback)actionClose ,NULL, NULL);
		notify_notification_set_hint_int32(notification,"x-ukui-popup-timeout",-1);
	}
	else if(strcmp(sigvalue,"error") == 0){
		fprintf(fp,"upgrade error!\n");
		notification = notify_notification_new (
				//gettext("System Update"),
				NULL,
				gettext("The backend is abnormal,please check for updates on settings."),
				"/usr/share/icons/ukui-icon-theme-default/16x16/apps/ukui-control-center.png");
		notify_notification_set_timeout(notification, 0);
		notify_notification_add_action(notification, "OK", gettext("OK"),
		(NotifyActionCallback)actionClose ,NULL, NULL);
	}
	else{
		fprintf(fp,"upgrade fail!\n");
		char str[50];
		memset(str,0,sizeof(str));
		char *str1 = gettext("upgrade fail! Error code(");
		fprintf(fp,"error code is %s\n",sigvalue);
		strcat(str,str1);
		strcat(str,sigvalue);
		strcat(str,")");
		notification = notify_notification_new (
				NULL,
				gettext(str),
				"/usr/share/icons/ukui-icon-theme-default/16x16/apps/ukui-control-center.png");
		notify_notification_set_timeout(notification, 0);
		notify_notification_add_action(notification, "OK", gettext("OK"), 
		(NotifyActionCallback)actionClose ,NULL, NULL);
		notify_notification_set_hint_int32(notification,"x-ukui-popup-timeout",-1);
	}
	error = NULL;
	success = notify_notification_show (notification, &error);
	if (!success){
		//g_print ("That did not work ... \"%s\".\n", error->message);
		fprintf (fp,"That did not work ... \"%s\".\n", error->message);  
		g_error_free (error);
	}
	g_signal_connect (G_OBJECT (notification),
			  "closed",
			  G_CALLBACK (closed_handler),
			  NULL);
	mainloop=g_main_loop_new(NULL, false);
	g_main_loop_run(mainloop);
	notify_uninit ();
	return 0;
}


void closed_handler(NotifyNotification* notification, gpointer data){	
	notify_uninit ();
	g_print ("closed_handler() called\n");
	g_main_loop_quit(mainloop);
	return;
}

void actionClose(NotifyNotification* notification,char *action, gpointer data){
	g_print("Closed\n");
	g_print ("dbus_method_called to change the sigvalue");
	return;
}