#ifndef APPUPDATE_H
#define APPUPDATE_H

#include <QPushButton>
#include <QWidget>
#include <QLabel>
#include <QHBoxLayout>
#include <QVBoxLayout>
#include <QDateTime>
#include <QTextEdit>
#include <QToolTip>
#include "utils.h"
#include "updatelog.h"
#include <QMetaType>
#include <QTimer>
#include "updatedbus.h"
#include <QCheckBox>
#include "mylabel.h"
#include "src/Data/global.h"
#include <kborderbutton.h>
#include <kborderlessbutton.h>
#include <kdialog.h>
#include "detaildialog.h"

#include <stdio.h>
#include <iostream>
#include <yaml-cpp/yaml.h>
#include <yaml-cpp/exceptions.h>
//#include <ukcc/interface/ukcccommon.h>
#include "ukcc/interface/upgradeukcccommon.h"
//#include <ukcc/widgets/lightlabel.h>
#include "ukcc/widgets/lightlabel.h"
class Detaildialog;
class UpdateLog;
using namespace kdk;
class AppUpdateWid : public QWidget
{
    Q_OBJECT
public:
    explicit AppUpdateWid(AppAllMsg msg, QWidget *parent = nullptr);
    ~AppUpdateWid();
//    Detaildialog *detaillog;

    QString appname = nullptr;

    QFrame *AppFrame;
    UpdateLog *updatelog1;
    UpdateDbus *m_updateMutual;
    //缩略界面
    QLabel *appIcon;
    QLabel *appIconName;
    MyLabel *appNameLab;
    FixLabel *appVersion;
    QLabel *appVersionIcon;

    QLabel *progressLab;  //进度
    QLabel *otherBtnLab;
    QLabel *versionLab;
    KBorderlessButton *detaileInfo;
    QPushButton *updateAPPBtn;
    QWidget *appTitleWid;
    QHBoxLayout *frameLayout;
    QHBoxLayout *iconNameLayout;
    QHBoxLayout *smallHLayout;
    QVBoxLayout *largeVLayout;
    QHBoxLayout *versionlabLayout;
    QHBoxLayout *otherBtnLayout;
    QWidget *largeWidget;
    QHBoxLayout *mainVLayout;
    //展开界面
    QTextEdit *someInfoEdit;  //详情内容
    QPushButton *updatelogBtn;
//    AppMsg *thisAppMessage;
    QString chlog;  //更新日志完整内容
    QString description;  //更新包描述
    QString setDefaultDescription(QString str); //将虚包包名汉化
    void updateOneApp(bool status);  //控制更新单个app
    QString dispalyName;
    QString modifySpeedUnit(long size, float time);
    void distUpgradePartial(bool status);
    void updateaccept();
    void updatecancel();
private:
    bool isCancel = false;
    int connectTimes = 0;
    bool downloadFinish = false;
    bool stopTimer = false;
    UrlMsg urlmsg;
    QString path;
    QString currentPackage;
    QStringList downloadList;
    QStringList downloadPackages;
    AppAllMsg appAllMsg;
    QProcess *downloadProcess;
    QProcess *workProcess;
    QTimer *timer;
    QString downloadPath;

    bool execFun = true;

public:
    bool isUpdateAll = false;
    bool isAutoUpgrade = false;
    bool haveThemeIcon = false;
    bool downloadstart = false;
    bool shutdown_install = false;

public slots:
    void showDetails();

    void updateAllApp();
private:
    void wgetDownload(UrlMsg msg, QString path); //断点续传下载
    bool getDownloadSpeed(QString appName, QString fullName, int fileSize); //获取下载速度
    void initConnect(); //初始化信号槽
    void changeDownloadState(int state);
    type checkSourcesType();
    QStringList analysis_config_file(char *p_file_path);
    void remove_last_enter(char *p_src_in_out);
    void enableupdateAPPBtn(bool enabled);//取消按钮是否置灰

    QMap<QString, QString> getNameAndIconFromJson(QString pkgname);

    enum Environment{
        en,
        zh_cn
    }environment;

signals:
    void startWork(QString appName);
    void startMove(QStringList list, QString appName);
    void oneappUpdateResultSignal(bool state,QStringList pkgname,QString error,QString reason);
    void changeUpdateAllSignal(bool isUpdate);
    void downloadFailedSignal(int exitCode);  //网络异常或者其他情况下下载失败时
    void appupdateiscancel();
    void sendProgress(QString pkgName, int Progress, QString type);
    void changeupdateall();
    void allappupdatefinishsignal();
    void startoneappupdate();
    void ShutdowninstallFinishSignal();//shutdownfinishsignal

private:
    void updateAppUi(QString name);
    QString translationVirtualPackage(QString str);
    QString pkgIconPath = "";
};

#endif // APPUPDATE_H
